// This file specifies constants used within the entire namespace.
// 
// Codon Optimizer - a reference implementation of the CAI optimization 
// and motif engineering algorithm by Anne Condon and Chris Thachuk. 
//
// Copyright (C) 2012 Chris Thachuk
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.


#ifndef _CONST_H_
#define _CONST_H_

namespace oligodesign {

enum od_aa {
  AA_ALA, AA_ARG, AA_ASN, AA_ASP, AA_CYS,
  AA_GLN, AA_GLU, AA_GLY, AA_HIS, AA_ILE,
  AA_LEU, AA_LYS, AA_MET, AA_PHE, AA_PRO,
  AA_SER, AA_THR, AA_TRP, AA_TYR, AA_VAL,
  AA_END
};

enum {DNA_A, DNA_C, DNA_G, DNA_T};

const int OD_MAX_SEQ_LENGTH = 65536;		/* 2^16 */
const int OD_NAA = 21;
const int OD_NBASES = 4;
const int OD_MAX_CODONS_PER_AA = 6;
const int OD_CODON_SIZE = 3;
const int OD_UNDEF = -1;
const int OD_I_INF = 65536;
const int OD_I_NINF = -65536;

const double OD_INF = 2e100;
const double OD_NINF = -2e100;

} // end namespace oligodesign

#endif /* _CONST_H_ */
